// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: dsepractice/chinese/v1alpha1/text_types.proto

package gg.dsepractice.chinese.v1alpha1;

/**
 * Protobuf type {@code dsepractice.chinese.v1alpha1.ParagraphNode}
 */
public  final class ParagraphNode extends
    com.google.protobuf.GeneratedMessageLite<
        ParagraphNode, ParagraphNode.Builder> implements
    // @@protoc_insertion_point(message_implements:dsepractice.chinese.v1alpha1.ParagraphNode)
    ParagraphNodeOrBuilder {
  private ParagraphNode() {
    fullText_ = "";
    nodes_ = emptyProtobufList();
  }
  public static final int FULL_TEXT_FIELD_NUMBER = 1;
  private java.lang.String fullText_;
  /**
   * <code>string full_text = 1 [json_name = "fullText"];</code>
   * @return The fullText.
   */
  @java.lang.Override
  public java.lang.String getFullText() {
    return fullText_;
  }
  /**
   * <code>string full_text = 1 [json_name = "fullText"];</code>
   * @return The bytes for fullText.
   */
  @java.lang.Override
  public com.google.protobuf.ByteString
      getFullTextBytes() {
    return com.google.protobuf.ByteString.copyFromUtf8(fullText_);
  }
  /**
   * <code>string full_text = 1 [json_name = "fullText"];</code>
   * @param value The fullText to set.
   */
  private void setFullText(
      java.lang.String value) {
    java.lang.Class<?> valueClass = value.getClass();
  
    fullText_ = value;
  }
  /**
   * <code>string full_text = 1 [json_name = "fullText"];</code>
   */
  private void clearFullText() {
    
    fullText_ = getDefaultInstance().getFullText();
  }
  /**
   * <code>string full_text = 1 [json_name = "fullText"];</code>
   * @param value The bytes for fullText to set.
   */
  private void setFullTextBytes(
      com.google.protobuf.ByteString value) {
    checkByteStringIsUtf8(value);
    fullText_ = value.toStringUtf8();
    
  }

  public static final int NODES_FIELD_NUMBER = 2;
  private com.google.protobuf.Internal.ProtobufList<gg.dsepractice.chinese.v1alpha1.SegmentNode> nodes_;
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
   */
  @java.lang.Override
  public java.util.List<gg.dsepractice.chinese.v1alpha1.SegmentNode> getNodesList() {
    return nodes_;
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
   */
  public java.util.List<? extends gg.dsepractice.chinese.v1alpha1.SegmentNodeOrBuilder> 
      getNodesOrBuilderList() {
    return nodes_;
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
   */
  @java.lang.Override
  public int getNodesCount() {
    return nodes_.size();
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
   */
  @java.lang.Override
  public gg.dsepractice.chinese.v1alpha1.SegmentNode getNodes(int index) {
    return nodes_.get(index);
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
   */
  public gg.dsepractice.chinese.v1alpha1.SegmentNodeOrBuilder getNodesOrBuilder(
      int index) {
    return nodes_.get(index);
  }
  private void ensureNodesIsMutable() {
    com.google.protobuf.Internal.ProtobufList<gg.dsepractice.chinese.v1alpha1.SegmentNode> tmp = nodes_;
    if (!tmp.isModifiable()) {
      nodes_ =
          com.google.protobuf.GeneratedMessageLite.mutableCopy(tmp);
     }
  }

  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
   */
  private void setNodes(
      int index, gg.dsepractice.chinese.v1alpha1.SegmentNode value) {
    value.getClass();
  ensureNodesIsMutable();
    nodes_.set(index, value);
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
   */
  private void addNodes(gg.dsepractice.chinese.v1alpha1.SegmentNode value) {
    value.getClass();
  ensureNodesIsMutable();
    nodes_.add(value);
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
   */
  private void addNodes(
      int index, gg.dsepractice.chinese.v1alpha1.SegmentNode value) {
    value.getClass();
  ensureNodesIsMutable();
    nodes_.add(index, value);
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
   */
  private void addAllNodes(
      java.lang.Iterable<? extends gg.dsepractice.chinese.v1alpha1.SegmentNode> values) {
    ensureNodesIsMutable();
    com.google.protobuf.AbstractMessageLite.addAll(
        values, nodes_);
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
   */
  private void clearNodes() {
    nodes_ = emptyProtobufList();
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
   */
  private void removeNodes(int index) {
    ensureNodesIsMutable();
    nodes_.remove(index);
  }

  public static gg.dsepractice.chinese.v1alpha1.ParagraphNode parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static gg.dsepractice.chinese.v1alpha1.ParagraphNode parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static gg.dsepractice.chinese.v1alpha1.ParagraphNode parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static gg.dsepractice.chinese.v1alpha1.ParagraphNode parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static gg.dsepractice.chinese.v1alpha1.ParagraphNode parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static gg.dsepractice.chinese.v1alpha1.ParagraphNode parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static gg.dsepractice.chinese.v1alpha1.ParagraphNode parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input);
  }
  public static gg.dsepractice.chinese.v1alpha1.ParagraphNode parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input, extensionRegistry);
  }
  public static gg.dsepractice.chinese.v1alpha1.ParagraphNode parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return parseDelimitedFrom(DEFAULT_INSTANCE, input);
  }
  public static gg.dsepractice.chinese.v1alpha1.ParagraphNode parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return parseDelimitedFrom(DEFAULT_INSTANCE, input, extensionRegistry);
  }
  public static gg.dsepractice.chinese.v1alpha1.ParagraphNode parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input);
  }
  public static gg.dsepractice.chinese.v1alpha1.ParagraphNode parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input, extensionRegistry);
  }

  public static Builder newBuilder() {
    return (Builder) DEFAULT_INSTANCE.createBuilder();
  }
  public static Builder newBuilder(gg.dsepractice.chinese.v1alpha1.ParagraphNode prototype) {
    return (Builder) DEFAULT_INSTANCE.createBuilder(prototype);
  }

  /**
   * Protobuf type {@code dsepractice.chinese.v1alpha1.ParagraphNode}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageLite.Builder<
        gg.dsepractice.chinese.v1alpha1.ParagraphNode, Builder> implements
      // @@protoc_insertion_point(builder_implements:dsepractice.chinese.v1alpha1.ParagraphNode)
      gg.dsepractice.chinese.v1alpha1.ParagraphNodeOrBuilder {
    // Construct using gg.dsepractice.chinese.v1alpha1.ParagraphNode.newBuilder()
    private Builder() {
      super(DEFAULT_INSTANCE);
    }


    /**
     * <code>string full_text = 1 [json_name = "fullText"];</code>
     * @return The fullText.
     */
    @java.lang.Override
    public java.lang.String getFullText() {
      return instance.getFullText();
    }
    /**
     * <code>string full_text = 1 [json_name = "fullText"];</code>
     * @return The bytes for fullText.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getFullTextBytes() {
      return instance.getFullTextBytes();
    }
    /**
     * <code>string full_text = 1 [json_name = "fullText"];</code>
     * @param value The fullText to set.
     * @return This builder for chaining.
     */
    public Builder setFullText(
        java.lang.String value) {
      copyOnWrite();
      instance.setFullText(value);
      return this;
    }
    /**
     * <code>string full_text = 1 [json_name = "fullText"];</code>
     * @return This builder for chaining.
     */
    public Builder clearFullText() {
      copyOnWrite();
      instance.clearFullText();
      return this;
    }
    /**
     * <code>string full_text = 1 [json_name = "fullText"];</code>
     * @param value The bytes for fullText to set.
     * @return This builder for chaining.
     */
    public Builder setFullTextBytes(
        com.google.protobuf.ByteString value) {
      copyOnWrite();
      instance.setFullTextBytes(value);
      return this;
    }

    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     */
    @java.lang.Override
    public java.util.List<gg.dsepractice.chinese.v1alpha1.SegmentNode> getNodesList() {
      return java.util.Collections.unmodifiableList(
          instance.getNodesList());
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     */
    @java.lang.Override
    public int getNodesCount() {
      return instance.getNodesCount();
    }/**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     */
    @java.lang.Override
    public gg.dsepractice.chinese.v1alpha1.SegmentNode getNodes(int index) {
      return instance.getNodes(index);
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     */
    public Builder setNodes(
        int index, gg.dsepractice.chinese.v1alpha1.SegmentNode value) {
      copyOnWrite();
      instance.setNodes(index, value);
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     */
    public Builder setNodes(
        int index, gg.dsepractice.chinese.v1alpha1.SegmentNode.Builder builderForValue) {
      copyOnWrite();
      instance.setNodes(index,
          builderForValue.build());
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     */
    public Builder addNodes(gg.dsepractice.chinese.v1alpha1.SegmentNode value) {
      copyOnWrite();
      instance.addNodes(value);
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     */
    public Builder addNodes(
        int index, gg.dsepractice.chinese.v1alpha1.SegmentNode value) {
      copyOnWrite();
      instance.addNodes(index, value);
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     */
    public Builder addNodes(
        gg.dsepractice.chinese.v1alpha1.SegmentNode.Builder builderForValue) {
      copyOnWrite();
      instance.addNodes(builderForValue.build());
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     */
    public Builder addNodes(
        int index, gg.dsepractice.chinese.v1alpha1.SegmentNode.Builder builderForValue) {
      copyOnWrite();
      instance.addNodes(index,
          builderForValue.build());
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     */
    public Builder addAllNodes(
        java.lang.Iterable<? extends gg.dsepractice.chinese.v1alpha1.SegmentNode> values) {
      copyOnWrite();
      instance.addAllNodes(values);
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     */
    public Builder clearNodes() {
      copyOnWrite();
      instance.clearNodes();
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     */
    public Builder removeNodes(int index) {
      copyOnWrite();
      instance.removeNodes(index);
      return this;
    }

    // @@protoc_insertion_point(builder_scope:dsepractice.chinese.v1alpha1.ParagraphNode)
  }
  @java.lang.Override
  @java.lang.SuppressWarnings({"unchecked", "fallthrough"})
  protected final java.lang.Object dynamicMethod(
      com.google.protobuf.GeneratedMessageLite.MethodToInvoke method,
      java.lang.Object arg0, java.lang.Object arg1) {
    switch (method) {
      case NEW_MUTABLE_INSTANCE: {
        return new gg.dsepractice.chinese.v1alpha1.ParagraphNode();
      }
      case NEW_BUILDER: {
        return new Builder();
      }
      case BUILD_MESSAGE_INFO: {
          java.lang.Object[] objects = new java.lang.Object[] {
            "fullText_",
            "nodes_",
            gg.dsepractice.chinese.v1alpha1.SegmentNode.class,
          };
          java.lang.String info =
              "\u0000\u0002\u0000\u0000\u0001\u0002\u0002\u0000\u0001\u0000\u0001\u0208\u0002\u001b" +
              "";
          return newMessageInfo(DEFAULT_INSTANCE, info, objects);
      }
      // fall through
      case GET_DEFAULT_INSTANCE: {
        return DEFAULT_INSTANCE;
      }
      case GET_PARSER: {
        com.google.protobuf.Parser<gg.dsepractice.chinese.v1alpha1.ParagraphNode> parser = PARSER;
        if (parser == null) {
          synchronized (gg.dsepractice.chinese.v1alpha1.ParagraphNode.class) {
            parser = PARSER;
            if (parser == null) {
              parser =
                  new DefaultInstanceBasedParser<gg.dsepractice.chinese.v1alpha1.ParagraphNode>(
                      DEFAULT_INSTANCE);
              PARSER = parser;
            }
          }
        }
        return parser;
    }
    case GET_MEMOIZED_IS_INITIALIZED: {
      return (byte) 1;
    }
    case SET_MEMOIZED_IS_INITIALIZED: {
      return null;
    }
    }
    throw new UnsupportedOperationException();
  }


  // @@protoc_insertion_point(class_scope:dsepractice.chinese.v1alpha1.ParagraphNode)
  private static final gg.dsepractice.chinese.v1alpha1.ParagraphNode DEFAULT_INSTANCE;
  static {
    ParagraphNode defaultInstance = new ParagraphNode();
    // New instances are implicitly immutable so no need to make
    // immutable.
    DEFAULT_INSTANCE = defaultInstance;
    com.google.protobuf.GeneratedMessageLite.registerDefaultInstance(
      ParagraphNode.class, defaultInstance);
  }

  public static gg.dsepractice.chinese.v1alpha1.ParagraphNode getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static volatile com.google.protobuf.Parser<ParagraphNode> PARSER;

  public static com.google.protobuf.Parser<ParagraphNode> parser() {
    return DEFAULT_INSTANCE.getParserForType();
  }
}

